#include <iostream>
#include <stack>

using namespace std;

const int N = 10; // rozmiar tablicy do posortowania
const int MINN = 0; // minimalna wartosc (do stosu lewego)
const int MAXX = 100; // maksymalna wartosc (do stosu prawego)

void displayStack(stack<int> a, string name) {
	cout << "=====" << name << "=====" << a.size() << endl;
	while (!a.empty()) {
		int tmp = a.top();
		if (tmp < 10) cout << "|" << tmp << " |\n";
		else cout << "|" << tmp << "|\n";  
		a.pop();
	}
	cout << "+--+" << endl;
	cout << "=====" << name << "=====\n";
}

int amain()
{
	stack<int> stosL, stosP;

	//int memCount[]{ 0, 0, 0 }; // do obliczania zlozonosci

	stosL.push(MINN);
	stosP.push(MAXX);

	int tab[N]/*{ 2, 8, 15, 1, 10, 5, 19, 18, 3, 5 }*/; // do testow z wartosciami

	for (int i = 0; i < N; i++) {
		tab[i] = (rand() % (MAXX - 1)) + MINN + 1; // zakres [MINN; MAXX]
		cout << tab[i] << " ";
	}
	cout << endl << endl;

	int mini = tab[0];
	int maxi = tab[0];
	for (int a : tab) { // wykonuje sie N razy
		if (a < mini) mini = a;
		if (a > maxi) maxi = a;
	}

	for (int v : tab) { // wykonuje sie N razy
		while (stosL.top() >= v) {
			stosP.push(stosL.top());
			//cout << "L > " << stosL.top() << " > P\n"; // do analizy
			stosL.pop();
			//memCount[0]++;
		}

		while (stosP.top() <= v) {
			stosL.push(stosP.top());
			//cout << "P > " << stosP.top() << " > L\n"; // do analizy
			stosP.pop();
			//memCount[1]++;
		}

		stosL.push(v);
	}

	/*displayStack(stosL, "lewy");
	displayStack(stosP, "prawy");*/

	while (stosL.empty() == false) { 
		stosP.push(stosL.top());
		//cout << "L > " << stosL.top() << " > P\n"; // do analizy
		stosL.pop();
		//memCount[2]++;
	}

	/*displayStack(stosL, "lewy");
	displayStack(stosP, "prawy");*/

	cout << endl;

	while (stosP.empty() == false) { // wykonuje sie N + 2 razy (+2 bo mamy wartosci MINN i MAXX na stosie)
		int tmp = stosP.top();
		if (tmp != MAXX && tmp != MINN) cout << tmp << " "; // pomijamy MINN i MAXX bo nie naleza do tab[]
		stosP.pop();
	}

	/*cout << endl << "L>P w tablicy: " << memCount[0] <<
		"\nP>L w tablicy: " << memCount[1] <<
		"\nL>P pod koniec: " << memCount[2];*/

	return 0;
}
